Subject: bug#67022: Gzip decompression can be 60% faster using zlib's CRC32

From: "Adler, Mark" <[email-masked]>
Date: Thu, 14 Mar 2024 18:00:30 +0000

Mr. Wrotycz,

I’m not sure what you mean by “bloated”, but anyway, the current code in zlib for CRC-32 does not use slice-by-8. It uses braids, which is faster. If there were going to be a replacement for the software CRC in gzip, it should start there.

It could also finish there, simply by copying all the code. It is, after all, open source.

As for the “magical”, any sufficiently advanced technology is indistinguishable from magic.  :-)

Mark

> On Mar 13, 2024, at 6:14 PM, wrotycz <[email-masked]> wrote:
> 
> I tried to implement this slice-by-8 CRC but couldn&#39;t do it the way I wanted - without bloated zlib tables and stuff. Maybe because I don&#39;t get what updcrc(), getcrc(), setcrc() are and what they actually do. The whole program is magical, there is no way to find do_de/compress(), nor anything like that, so it was difficult to actually find relevant code. But anyway, for a start I manged to make `makecrcs8.c&#39; to generate CRCs lookup table (attached).   Regards  wrotycz
> <makecrcs8.c>